con
 _clkmode  = xtal1 + pll16x
  _xinfreq  = 5_000_000
   
video     = 12 
spiDO     = 10   
spiClk    = 11   
spiDI     = 9    
spiCS     = 0


obj
text       : "retrotext"
kb      : "keyboard"
sd:    "fsrwfemto"
sram:   "sramc3"



var
long ioControl[2]
byte openbuff[12]     
byte buff[32]
byte chardata, val1, val2, val3, val4, val5, val6, val7, val8, tempchar, val9
byte testbuff
byte timecount, texty, textx
byte custbuff[8]
byte sdbuff[950]
long counter, counter2, r, counter3
byte cursor, cursor2, menu, menupoint, menublock, fileopen, fileopen2


pub main

custbuff[0] := %11000000
custbuff[1] := %11000000
custbuff[2] := %11000000
custbuff[3] := %11000000
custbuff[4] := %11000000
custbuff[5] := %11000000 
custbuff[6] := %11000000
custbuff[7] := %11000000

text.redefine("^",custbuff[0], custbuff[1],custbuff[2], custbuff[3],custbuff[4], custbuff[5] ,custbuff[6], custbuff[7])

waitcnt(clkfreq/10 + cnt)
text.start(video)
kb.start(26, 27)
text.out(0)
text.locate(12,12)
text.color(text#PURPLE)
text.str(string("PASos NotepadV1"))
sram.spi_init
sram.spi_select_channel(1)
sram.sram_init(%0100_0001)
waitcnt(clkfreq/10 + cnt)
sram.sram64k_mwrite(0,"Y")
waitcnt(clkfreq/10 + cnt)
testbuff := sram.sram64k_mread(0)
sram.sram_fill(0,0,1000," ")
text.locate(12,14)
if testbuff[0] == "Y"
 text.str(string("SRAM Found"))

sram.spi_init
sram.spi_select_channel(5)                                    
sd.start(@iocontrol)
if \sd.mount(spiDO,spiClk,spiDI,spiCS) == 0
 text.locate(12,15)
 text.str(string("SD Found"))  

 if \sd.mount(spiDO,spiClk,spiDI,spiCS) > 0
   abort

sd.stop
sram.spi_init
sram.spi_select_channel(1)
sram.sram_init(%0100_0001)
  
text.updatescreen                                  
waitcnt(clkfreq * 2 + cnt)



   
text.out(0)
text.locate(0,1)
text.color(text#PURPLE)
text.str(string("_______________________________________"))
text.locate(0,0)
text.color(text#BLUE)
text.str(string("|New|    |Open|    |Save|   |Options|  "))  
text.updatescreen
waitcnt(clkfreq/ 2 + cnt)
text.locate(0,4)
texty := 2
repeat
 if fileopen == 0
  chardata := 0
  readkb

 
 if chardata > 0
  val5 := 0
  timecount := 1


 if timecount == 0 and fileopen == 0 
  text.locate(textx, texty)
  text.out("^")
  text.updatescreen
 if timecount == 1
  text.locate(textx, texty)
  tempchar := localramread(textx, texty)
  if tempchar == 0
   tempchar := " "
  text.out(tempchar)
 

 textx #>= 0
 textx <#= 39

 texty #>= 2
 texty <#= 25

 if chardata > 0 and timecount == 0
  timecount := 1
  

 

 
 

 
   
 if chardata == 192 and menu == 0 
  
  textx--
   
  chardata := 0

 if chardata == 193  and menu == 0
  textx++
  
  chardata := 0

 if chardata == 194  and menu == 0   
   
  val8 := 1
  val9 := 0
  texty--
  
  chardata := 0
 
 if chardata == 195  and menu == 0   
   
  val8 := 2
  val9 := 0
  texty++
  
  chardata := 0

 textx #>= 0
 textx <#= 39

 texty #>= 2
 texty <#= 25 

 if chardata == 13 and menu == 1 and menupoint == 1
  text.locate(0,0)
  text.color(text#RED)
  text.str(string("New?   Y = yes    N = No              "))
  text.updatescreen
   repeat
    chardata := 0
    readkb
     if chardata == "y" or chardata == "Y"
      textx := 0
      texty := 2
      cursor := " "
      menupoint := 0
      sram.sram_fill(0,0,1000," ")  
      menu := 0
      text.out(0)
      text.locate(0,1)
      text.color(text#PURPLE)
      text.str(string("_______________________________________"))
      text.locate(0,0)
      text.color(text#BLUE)
      text.str(string("|New|    |Open|    |Save|   |Options|  "))
      quit
      

     if chardata == "n" or chardata == "N"
      text.locate(0,0)
      text.color(text#BLUE)
      text.str(string("|New|    |Open|    |Save|   |Options|  "))
       text.color(Text#GREEN)  
      text.locate(0,0)
      text.out(">")
      text.locate(4,0) 
      text.out("<")
      menupoint := 0
      quit



 if chardata == 13 and menu == 1 and menupoint == 2
  chardata := 0
  text.locate(0,0)
  text.color(text#RED)
  text.str(string("Open file? (            )            "))
  text.updatescreen
  val4 := 12
  val4 #>= 12
  val5 := 0
  repeat
   chardata := 0
   readkb
    if chardata > 0 and chardata <> 203 and chardata <> 200
     text.locate(val4, 0)
     text.out(chardata)
     openbuff[val5] := chardata
     val5++
     val4++

    if chardata == 200
     val4--
     val5--
     text.locate(val4, 0)
     text.out(" ")
     openbuff[val5] := " "

    if chardata == 203
     text.locate(0,0)
     text.color(text#BLUE)
     text.str(string("|New|    |Open|    |Save|   |Options|  "))
     text.locate(0,1)
      text.color(text#PURPLE)
      text.str(string("_______________________________________"))
     text.color(Text#GREEN)  
     text.locate(0,0)
     text.out(">")
     text.locate(4,0) 
     text.out("<")
     menupoint := 0
     quit



   if chardata == 13
    counter := 0
    counter2 := 0
     text.out(0)
     sram.spi_init
     sram.spi_select_channel(5)
     sd.start(@iocontrol)
     sd.mount(spiDO,spiClk,spiDI,spiCS)
     sd.popen(@openbuff, "r")
     sd.pread(@sdbuff, 950)
     sd.pclose
     sd.stop
     waitcnt(clkfreq/100 + cnt)
     sram.spi_init
     sram.spi_select_channel(1)
     sram.sram_init(%0100_0001)
     sram.sram_write(0, 78, 950, @sdbuff)  
     bytefill(@sdbuff, " ", 950)
     waitcnt(clkfreq/40 + cnt)
       
     
    textx := 0
    texty := 1
    menupoint := 0
    menu := 0
    text.locate(0,0)
    text.color(text#BLUE)
    text.str(string("|New|    |Open|    |Save|   |Options|  "))
    text.locate(0,1)
      text.color(text#PURPLE)
      text.str(string("_______________________________________"))
    text.color(Text#GREEN)
    text.updatescreen 
    fileopen := 1
    fileopen2 := 1
    quit  

     
   text.updatescreen                            
   waitcnt(clkfreq/20 + cnt)


 if fileopen == 1
  textx++
   if textx == 38
    texty++
    textx := 0

  if texty == 25
   textx := 0
   texty := 0
   fileopen := 0
 
     
 if chardata == 13 and menu == 1 and menupoint == 3
  chardata := 0
  text.locate(0,0)
  text.color(text#RED)
  text.str(string("Save file as? (            )            "))
  text.updatescreen 
   val4 := 15
   val4 #>= 15
   val5 := 0
  fileopen := 0
  repeat
   chardata := 0
   readkb
   if chardata == 203
    text.locate(0,0)
    text.color(text#BLUE)
    text.str(string("|New|    |Open|    |Save|   |Options|  "))
    text.color(Text#GREEN)  
    text.locate(0,0)
    text.out(">")
    text.locate(4,0) 
    text.out("<")
    menupoint := 0
    quit

   if chardata > 0 and chardata <> 203 and chardata <> 200
    text.locate(val4, 0)
    text.out(chardata)
    openbuff[val5] := chardata
    val5++
    val4++

   if chardata == 200
    val4--
    val5--
    text.locate(val4, 0)
    text.out(" ")
    openbuff[val5] := " "

   if chardata == 13
    chardata := 0
    
    counter := 0
    counter2 := 0
    bytefill(@sdbuff, " ", 950)
    sram.sram_read(0, 78, 950, @sdbuff)
    waitcnt(clkfreq/10 + cnt)
    sram.spi_init    
    sram.spi_select_channel(5)
    waitcnt(clkfreq/ 40 + cnt)
    sd.start(@iocontrol)
    sd.mount(spiDO,spiClk,spiDI,spiCS)
    sd.popen(@openbuff, "w")
    sd.pwrite(@sdbuff, 950)
    waitcnt(clkfreq/20 + cnt)
    sd.pclose
    sd.stop
    bytefill(@openbuff, 0, 12)
    waitcnt(clkfreq/ 10 + cnt)
    sram.spi_init
     sram.spi_select_channel(1)
     sram.sram_init(%0100_0001)
     menu := 0
     menupoint := 0
    text.locate(0,0)
     text.color(text#BLUE)
     text.str(string("|New|    |Open|    |Save|   |Options|  "))
     text.locate(0,1)
      text.color(text#PURPLE)
      text.str(string("_______________________________________")) 
    quit
    
   text.updatescreen                            
   waitcnt(clkfreq/20 + cnt)

       
 val2++
 
 if val2 == 5
   timecount++
   val2 := 0
    if timecount == 2
     timecount := 0

 if fileopen == 1
  timecount := 1
 
 if chardata == 200
  textx--
  text.locate(textx, texty)
  text.out(" ")
  localramwrite(textx, texty," ") 
  chardata := 0

 if chardata == 13
   
  texty++
  textx := 0
  text.locate(textx, texty)
  r := localramread(textx, texty)
  if r == 0
   r := " "
  text.out(r)
  chardata := 0
  

  
  


 if chardata > 0 and menu == 0 and chardata <> 203 and chardata <> "~"
    
  text.locate(textx, texty)
  text.color(Text#GREEN)
  text.out(Chardata)
  localramwrite(textx, texty, chardata)
  if tempchar <> " " or tempchar > 0
   textx++
  


  
 if chardata == 203 and menu == 1
  text.locate(0,0)
  text.color(text#BLUE)
  text.str(string("|New|    |Open|    |Save|   |Options|  "))
  menupoint := 0

 if chardata == 203 
  menu++
  chardata := 0

 if menu == 2
  menu := 0

 if menu == 0
  menublock := 0
   
 if menu == 1 and menupoint == 0 and menublock == 0
  text.locate(0,0)
  text.out(">")
  text.locate(4,0) 
  text.out("<")
  menublock++
  menupoint++



 
 
 


   
    
 if chardata == 193 and menu == 1 and menupoint == 0
  text.locate(28,0)
  text.out(":")
  text.locate(36,0) 
  text.out(":")  
  text.locate(0,0)
  text.out(">")
  text.locate(4,0) 
  text.out("<")
  menupoint++
  chardata := 0

 if chardata == 193 and menu == 1 and menupoint == 1
  text.locate(0,0)
  text.out(":")
  text.locate(4,0) 
  text.out(":")  
  text.locate(9,0)
  text.out(">")
  text.locate(14,0) 
  text.out("<")
  menupoint++
  chardata := 0


 if chardata == 193 and menu == 1 and menupoint == 2
  text.locate(9,0)
  text.out(":")
  text.locate(14,0) 
  text.out(":")  
  text.locate(19,0)
  text.out(">")
  text.locate(24,0) 
  text.out("<")
  menupoint++
  chardata := 0

 if chardata == 193 and menu == 1 and menupoint == 3
  text.locate(19,0)
  text.out(":")
  text.locate(24,0) 
  text.out(":")  
  text.locate(28,0)
  text.out(">")
  text.locate(36,0) 
  text.out("<")
  menupoint := 0                              
  chardata := 0

 
 if chardata == "~"
  r := localramread(textx, texty)
  if r == 0
   r := " "
  text.locate(20,20) 
  text.out(r)
  
 text.color(Text#GREEN)
 if fileopen == 0    
  text.updatescreen
  waitcnt(clkfreq/18 + cnt)  





pub localramwrite(x, y, val)| temp, temp2
temp2 := y - 2   
temp := y * 39 + x + temp2
sram.sram64k_mwrite(temp, val)

 

pub localramread(x, y)| temp, returnval, temp2




temp2 := y - 2
temp := y * 39 + x +  temp2
returnval := sram.sram64k_mread(temp)

if returnval < 0
 returnval := " "   
return returnval

pub readkb
if kb.gotKey
 chardata := kb.getKey